### POST /assemblies/d/{did}/w/{wid}/e/{eid}/instances Source: https://cad.onshape.com/api/openapi Part Studio instances may include multiple parts. ```markdown ### Parameters - **did** (string, path, required) - **wid** (string, path, required) - **eid** (string, path, required) ### Request Body **Content-Type:** application/json;charset=UTF-8; qs=0.09 - **configuration** (string) - **documentId** (string) (required) - **elementId** (string) - **featureId** (string) - **includePartTypes** (array (GBTInsertableType)) - **isAssembly** (boolean) - **isHidden** (boolean) - **isSuppressed** (boolean) - **isWholePartStudio** (boolean) - **microversionId** (string) - **partId** (string) - **partNumber** (string) - **revision** (string) - **versionId** (string) ### Responses #### default - default response ### Example Usage ```bash curl -X POST "https://cad.onshape.com/api/v16/assemblies/d/{did}/w/{wid}/e/{eid}/instances" \ -H "Content-Type: application/json" \ -d '{ "configuration": "string", "documentId": "string", "elementId": "string", "featureId": "string", "includePartTypes": [ "value" ], "isAssembly": "true", "isHidden": "true", "isSuppressed": "true", "isWholePartStudio": "true", "microversionId": "string", "partId": "string", "partNumber": "string", "revision": "string", "versionId": "string" }' ``` ``` -------------------------------- ### GET /webhooks Source: https://cad.onshape.com/api/openapi See [API Guide: Webhooks](https://onshape-public.github.io/docs/app-dev/webhook/) for implementation details. ```markdown ### Parameters - **company** (string, query, optional) - **user** (string, query, optional) - **offset** (integer (int32), query, optional) - **limit** (integer (int32), query, optional) ### Responses #### default - default response **BTListResponseBTWebhookInfo** - **href** (string (uri)): URI for current page of resources. - **items** (array (BTWebhookInfo)): Array of items in the current page. Array items: - **companyId** (string): Company admins can register webhooks to listen to all company events. - **createdAt** (string (date-time)) - **createdBy** (object) - **href** (string (uri)): URI to fetch complete information of the resource. - **id** (string): Id of the resource. - **name** (string): Name of the resource. - **viewRef** (string (uri)): URI to visualize the resource in a webclient if applicable. - **image** (string) - **isOnshapeSupport** (boolean) - **state** (integer (int32)) - **documentationName** (string) - **email** (string) - **firstName** (string) - **lastName** (string) - **company** (object) - **admin** (boolean) - **description** (string) - **domainPrefix** (string) - **enterpriseBaseUrl** (string) - **enterpriseSubtype** (integer (int32)) - **href** (string (uri)): URI to fetch complete information of the resource. - **id** (string): Id of the resource. - **image** (string) - **name** (string): Name of the resource. - **noPublicDocuments** (boolean) - **ownerId** (string) - **secondaryDomainPrefixes** (array (string)) - **state** (integer (int32)) - **type** (integer (int32)) - **viewRef** (string (uri)): URI to visualize the resource in a webclient if applicable. - **confirmationRequested** (boolean) - **documentationNameOverride** (string) - **globalPermissions** (object) - **accessReports** (boolean) - **adminEnterprise** (boolean) - **allowAppStoreAccess** (boolean) - **allowPublicDocumentsAccess** (boolean) - **approveReleases** (boolean) - **branchLockPermissions** (boolean) - **createDocumentsInRoot** (boolean) - **createProject** (boolean) - **createReleases** (boolean) - **createTasks** (boolean) - **deletePermanently** (boolean) - **exportFiles** (boolean) - **importFiles** (boolean) - **manageGuestUsers** (boolean) - **manageNonGeometricItems** (boolean) - **manageRbac** (boolean) - **manageStandardContentMetadata** (boolean) - **manageUsers** (boolean) - **manageWorkflows** (boolean) - **shareForAnonymousAccess** (boolean) - **transferDocumentsFromEnterprise** (boolean) - **useRevisionTools** (boolean) - **invitationState** (integer (int32)) - **isExternal** (boolean) - **isGuest** (boolean) - **isLight** (boolean) - **lastLoginTime** (string (date-time)) - **personalMessageAllowed** (boolean) - **source** (integer (int32)) - **data** (string) - **description** (string) - **droppedEventCount** (integer (int32)) - **events** (array (string)): List of events for which webhook callback is invoked. - **externalSessionId** (string): Applications can pass this parameter as X-Session-ID with every REST call to distinguish webhooks triggered by self. - **filter** (string) - **folderId** (string) - **href** (string (uri)): URI to fetch complete information of the resource. - **id** (string): Id of the resource. - **isTransient** (boolean): Transient webhooks are automatically cleaned up after a period of inactivity. - **modifiedAt** (string (date-time)) - **name** (string): Name of the resource. - **options** (object) - **collapseEvents** (boolean) - **projectId** (string) - **url** (string) - **viewRef** (string (uri)): URI to visualize the resource in a webclient if applicable. - **next** (string (uri)): URI for next page of the resources if more are available. - **previous** (string (uri)): URI for previous page of the resources. ### Example Usage ```bash curl -X GET "https://cad.onshape.com/api/v16/webhooks?company=&user=string&offset=0&limit=20" ``` ``` -------------------------------- ### API Overview: Onshape REST API Source: https://cad.onshape.com/api/openapi ## Welcome to the Onshape REST API Explorer **See the [API Explorer Guide](https://onshape-public.github.io/docs/api-intro/explorer/) for help navigating this page.** ### Using this page 1. Sign in to your [Onshape](https://cad.onshape.com) account in another tab. 2. Click the `Try it out` button below. It toggles to a `Cancel` button when selected. ### Authenticating To authenticate your calls, click the `Authorize` button. See [API Explorer Guide: Authentication](https://onshape-public.github.io/docs/api-intro/explorer/#authentication) for details. Calls made when authenticated via API Keys or OAuth count against your annual [API limits](https://onshape-public.github.io/docs/auth/limits/#annual-api-call-limits). * **Tip:** To ensure the current session isn't used when trying other authentication techniques, make sure to [remove the Onshape cookie](https://support.google.com/chrome/answer/95647#zippy=%2Cdelete-cookies-from-a-site) as per the instructions for your browser, or use a private or incognito window. ### Additional resources * [Onshape API Guide](https://onshape-public.github.io/docs/): Our full suite of developer guides, to be used as an accompaniment to this API Explorer. * [Onshape Developer Portal](https://cad.onshape.com/appstore/dev-portal): The Onshape portal for managing your API keys, OAuth2 credentials, your Onshape applications, and your Onshape App Store entries. * [Authentication Guide](https://onshape-public.github.io/docs/auth/): Our guide to using API keys, request signatures, and OAuth2 in your Onshape applications. ```yaml # Onshape REST API # Version: 1.215.79514-81c330f03091 ## Welcome to the Onshape REST API Explorer **See the [API Explorer Guide](https://onshape-public.github.io/docs/api-intro/explorer/) for help navigating this page.** ### Using this page 1. Sign in to your [Onshape](https://cad.onshape.com) account in another tab. 2. Click the `Try it out` button below. It toggles to a `Cancel` button when selected. ### Authenticating To authenticate your calls, click the `Authorize` button. See [API Explorer Guide: Authentication](https://onshape-public.github.io/docs/api-intro/explorer/#authentication) for details. Calls made when authenticated via API Keys or OAuth count against your annual [API limits](https://onshape-public.github.io/docs/auth/limits/#annual-api-call-limits). * **Tip:** To ensure the current session isn't used when trying other authentication techniques, make sure to [remove the Onshape cookie](https://support.google.com/chrome/answer/95647#zippy=%2Cdelete-cookies-from-a-site) as per the instructions for your browser, or use a private or incognito window. ### Additional resources * [Onshape API Guide](https://onshape-public.github.io/docs/): Our full suite of developer guides, to be used as an accompaniment to this API Explorer. * [Onshape Developer Portal](https://cad.onshape.com/appstore/dev-portal): The Onshape portal for managing your API keys, OAuth2 credentials, your Onshape applications, and your Onshape App Store entries. * [Authentication Guide](https://onshape-public.github.io/docs/auth/): Our guide to using API keys, request signatures, and OAuth2 in your Onshape applications. # Base URL: https://cad.onshape.com/api/v16 ``` -------------------------------- ### GET /webhooks/{webhookid} Source: https://cad.onshape.com/api/openapi See [API Guide: Webhooks](https://onshape-public.github.io/docs/app-dev/webhook/) for implementation details. ```markdown ### Parameters - **webhookid** (string, path, required) ### Responses #### default - default response **BTWebhookInfo** - **companyId** (string): Company admins can register webhooks to listen to all company events. - **createdAt** (string (date-time)) - **createdBy** (object) - **href** (string (uri)): URI to fetch complete information of the resource. - **id** (string): Id of the resource. - **name** (string): Name of the resource. - **viewRef** (string (uri)): URI to visualize the resource in a webclient if applicable. - **image** (string) - **isOnshapeSupport** (boolean) - **state** (integer (int32)) - **documentationName** (string) - **email** (string) - **firstName** (string) - **lastName** (string) - **company** (object) - **admin** (boolean) - **description** (string) - **domainPrefix** (string) - **enterpriseBaseUrl** (string) - **enterpriseSubtype** (integer (int32)) - **href** (string (uri)): URI to fetch complete information of the resource. - **id** (string): Id of the resource. - **image** (string) - **name** (string): Name of the resource. - **noPublicDocuments** (boolean) - **ownerId** (string) - **secondaryDomainPrefixes** (array (string)) - **state** (integer (int32)) - **type** (integer (int32)) - **viewRef** (string (uri)): URI to visualize the resource in a webclient if applicable. - **confirmationRequested** (boolean) - **documentationNameOverride** (string) - **globalPermissions** (object) - **accessReports** (boolean) - **adminEnterprise** (boolean) - **allowAppStoreAccess** (boolean) - **allowPublicDocumentsAccess** (boolean) - **approveReleases** (boolean) - **branchLockPermissions** (boolean) - **createDocumentsInRoot** (boolean) - **createProject** (boolean) - **createReleases** (boolean) - **createTasks** (boolean) - **deletePermanently** (boolean) - **exportFiles** (boolean) - **importFiles** (boolean) - **manageGuestUsers** (boolean) - **manageNonGeometricItems** (boolean) - **manageRbac** (boolean) - **manageStandardContentMetadata** (boolean) - **manageUsers** (boolean) - **manageWorkflows** (boolean) - **shareForAnonymousAccess** (boolean) - **transferDocumentsFromEnterprise** (boolean) - **useRevisionTools** (boolean) - **invitationState** (integer (int32)) - **isExternal** (boolean) - **isGuest** (boolean) - **isLight** (boolean) - **lastLoginTime** (string (date-time)) - **personalMessageAllowed** (boolean) - **source** (integer (int32)) - **data** (string) - **description** (string) - **droppedEventCount** (integer (int32)) - **events** (array (string)): List of events for which webhook callback is invoked. - **externalSessionId** (string): Applications can pass this parameter as X-Session-ID with every REST call to distinguish webhooks triggered by self. - **filter** (string) - **folderId** (string) - **href** (string (uri)): URI to fetch complete information of the resource. - **id** (string): Id of the resource. - **isTransient** (boolean): Transient webhooks are automatically cleaned up after a period of inactivity. - **modifiedAt** (string (date-time)) - **name** (string): Name of the resource. - **options** (object) - **collapseEvents** (boolean) - **projectId** (string) - **url** (string) - **viewRef** (string (uri)): URI to visualize the resource in a webclient if applicable. ### Example Usage ```bash curl -X GET "https://cad.onshape.com/api/v16/webhooks/{webhookid}" ``` ``` -------------------------------- ### POST /appelements/d/{did}/w/{wid}/bulkcreate Source: https://cad.onshape.com/api/openapi Call this faster API instead of creating multiple app elements one at a time or in parallel. ```markdown ### Parameters - **did** (string, path, required): The id of the document in which to perform the operation. - **linkDocumentId** (string, query, optional): The id of the document through which the above document should be accessed; only applicable when accessing a version of the document. This allows a user who has access to document a to see data from document b, as long as document b has been linked to document a by a user who has permission to both. - **wid** (string, path, required): The id of the workspace in which to perform the operation. ### Request Body **Content-Type:** application/json;charset=UTF-8; qs=0.09 - **description** (string): The label that will appear in the document's edit history for this operation. If blank, a value will be auto-generated. - **formatId** (string) (required): The data type of the application. This string allows an application to distinguish their elements from elements of another application. - **location** (object): The location at which the new element should be inserted. - **elementId** (string): The id of an element which provides context for the position value specified. - **position** (integer (int32)): An indicator for the relative placement of the new element. If elementId is specified, a negative number indicates insertion prior to the element and a non-negative number indicates insertion following the element. If no elementId is specified, a negative value indicates insertion at the end of the element list and a non-negative number indicates insertion at the start of the element list. - **names** (array (string)): The name of the element being created. If blank, a name will be auto-generated. ### Responses #### default - default response **BTAppElementBulkCreateInfo** - **documentMicroversionId** (string) (required): The latest document microversion, after the edit was committed. - **elementIds** (array (string)): The ids of the created elements. - **elementMicroversions** (array (string)): The microversion ids of the created elements, at creation time. - **errorCode** (integer (int32)): `0: OK (healthy) | 1: INFO | 2: WARNING | 3: ERROR (dangling or view generation call failed) | 4: UNKNOWN` - **errorDescription** (string): A human-readable value for the error that occurred, if one occurred. - **errorValue** (string (OK|TRANSACTION_CONFLICT|NOT_FOUND|INCONSISTENT_CHANGES)) ("OK"|"TRANSACTION_CONFLICT"|"NOT_FOUND"|"INCONSISTENT_CHANGES") ### Example Usage ```bash curl -X POST "https://cad.onshape.com/api/v16/appelements/d/{did}/w/{wid}/bulkcreate?linkDocumentId=" \ -H "Content-Type: application/json" \ -d '{ "description": "string", "formatId": "string", "location": "value", "names": [ "string" ] }' ``` ``` -------------------------------- ### GET /openapi/tags Source: https://cad.onshape.com/api/openapi Tags are used to group operations. For example, `Document` groups operations on documents. ```markdown ### Responses #### default - default response - Array of Tag - Array of Tag ### Example Usage ```bash curl -X GET "https://cad.onshape.com/api/v16/openapi/tags" ``` ``` -------------------------------- ### GET /elements/translatorFormats/{did}/{wv}/{wvid}/{eid} Source: https://cad.onshape.com/api/openapi See the [Translation API Guide](https://onshape-public.github.io/docs/api-adv/translation/) for additional details. ```markdown ### Parameters - **did** (string, path, required): The id of the document in which to perform the operation. - **linkDocumentId** (string, query, optional): The id of the document through which the above document should be accessed; only applicable when accessing a version of the document. This allows a user who has access to document a to see data from document b, as long as document b has been linked to document a by a user who has permission to both. - **wv** (string (w|v), path, required): Indicates which of workspace (w) or version (v) id is specified below. - **wvid** (string, path, required): The id of the workspace, version in which the operation should be performed. - **eid** (string, path, required): The id of the element in which to perform the operation. - **checkContent** (boolean, query, optional) - **configuration** (string, query, optional) ### Responses #### default - default response - Array of BTModelFormatInfo ### Example Usage ```bash curl -X GET "https://cad.onshape.com/api/v16/elements/translatorFormats/{did}/{wv}/{wvid}/{eid}?linkDocumentId=&checkContent=true&configuration=" ``` ``` -------------------------------- ### POST /documents/{did}/w/{wid}/restore/{vm}/{vmid} Source: https://cad.onshape.com/api/openapi API endpoint for POST /documents/{did}/w/{wid}/restore/{vm}/{vmid} ```markdown ### Parameters - **did** (string, path, required): The id of the document in which to perform the operation. - **linkDocumentId** (string, query, optional): The id of the document through which the above document should be accessed; only applicable when accessing a version of the document. This allows a user who has access to document a to see data from document b, as long as document b has been linked to document a by a user who has permission to both. - **wid** (string, path, required): The id of the workspace in which to perform the operation. - **vm** (string, path, required) - **vmid** (string, path, required) ### Request Body **Content-Type:** application/json;charset=UTF-8; qs=0.09 - **defaultRestoreStrategy** (string (KEEP|REPLACE)) ("KEEP"|"REPLACE") - **elementIdToStrategyOverride** (object) ### Responses #### default - default response **BTRestoreFromHistoryInfo** - **newMicroversion** (string) ### Example Usage ```bash curl -X POST "https://cad.onshape.com/api/v16/documents/{did}/w/{wid}/restore/{vm}/{vmid}?linkDocumentId=" \ -H "Content-Type: application/json" \ -d '{ "defaultRestoreStrategy": "value", "elementIdToStrategyOverride": "value" }' ``` ``` -------------------------------- ### GET /items Source: https://cad.onshape.com/api/openapi Returns a list of all items owned by the company/classroom/enterprise. Either `documentId` or `companyId` must be provided. ```markdown ### Parameters - **documentId** (string, query, optional): ID of any document owned by the company/classroom/enterprise. - **companyId** (string, query, optional): Company/classroom/enterprise ID. - **q** (string, query, optional): Optional search string. - **publishStates** (string, query, optional): Refine returned items by publish states: `0: PENDING | 1: ACTIVE | 2: INACTIVE` - **classification** (string, query, optional): Refine returned items by classification. Classifications are managed in company/classroom/enterprise [Properties settings](https://cad.onshape.com/help/Content/Plans/items.htm#item-class). - **offset** (integer (int32), query, optional): Number of entries to skip in the returned list. - **limit** (integer (int32), query, optional): The number of list entries to return in a single API call. ### Responses #### default - default response **BTListResponseBTItemInfo** - **href** (string (uri)): URI for current page of resources. - **items** (array (BTItemInfo)): Array of items in the current page. Array items: - **companyId** (string): ID of the company, classroom, or enterprise that owns this item. - **href** (string (uri)): URI to fetch complete information of the resource. - **id** (string): Id of the resource. - **name** (string): Name of the resource. - **properties** (object): Map of the item's properties and their values. - **publishState** (integer (int32)): `0: PENDING | 1: ACTIVE | 2: INACTIVE` - **viewRef** (string (uri)): URI to visualize the resource in a webclient if applicable. - **next** (string (uri)): URI for next page of the resources if more are available. - **previous** (string (uri)): URI for previous page of the resources. ### Example Usage ```bash curl -X GET "https://cad.onshape.com/api/v16/items?documentId=string&companyId=string&q=&publishStates=&classification=&offset=0&limit=30" ``` ``` -------------------------------- ### GET /blobelements/d/{did}/w/{wid}/e/{eid} Source: https://cad.onshape.com/api/openapi See [API Guide: Model Translation](https://onshape-public.github.io/docs/api-adv/translation/) for more details. ```markdown ### Parameters - **did** (string, path, required): The id of the document in which to perform the operation. - **linkDocumentId** (string, query, optional): The id of the document through which the above document should be accessed; only applicable when accessing a version of the document. This allows a user who has access to document a to see data from document b, as long as document b has been linked to document a by a user who has permission to both. - **wid** (string, path, required): The id of the workspace in which to perform the operation. - **eid** (string, path, required): The id of the element in which to perform the operation. - **contentDisposition** (string, query, optional): If "attachment", includes a Content-Disposition return header with the filename. - **If-None-Match** (string, header, optional): Entity tag; an md5 checksum of the data in double quotes. If the data to download has the same checksum as this entity tag, a 304 'Not Modified' status will be returned. The entity tag is returned in the response headers as ETag. ### Responses #### default - File download. ### Example Usage ```bash curl -X GET "https://cad.onshape.com/api/v16/blobelements/d/{did}/w/{wid}/e/{eid}?linkDocumentId=&contentDisposition=string" ``` ``` -------------------------------- ### GET /partstudios/d/{did}/{wvm}/{wvmid}/e/{eid}/features Source: https://cad.onshape.com/api/openapi See the [Features API Guide](https://onshape-public.github.io/docs/api-adv/featureaccess/) for additional information. ```markdown ### Parameters - **did** (string, path, required): The id of the document in which to perform the operation. - **linkDocumentId** (string, query, optional): The id of the document through which the above document should be accessed; only applicable when accessing a version of the document. This allows a user who has access to document a to see data from document b, as long as document b has been linked to document a by a user who has permission to both. - **wvm** (string (w|v|m), path, required): Indicates which of workspace (w), version (v), or document microversion (m) id is specified below. - **wvmid** (string, path, required): The id of the workspace, version or document microversion in which the operation should be performed. - **eid** (string, path, required): The id of the element in which to perform the operation. - **configuration** (string, query, optional): URL-encoded string of configuration values (separated by `;`). See the [Configurations API Guide](https://onshape-public.github.io/docs/api-adv/configs/) for details. - **rollbackBarIndex** (integer (int32), query, optional): Index specifying the location of the rollback bar when the call is evaluated. A -1 indicates that it should be at the end of the featurelist. - **elementMicroversionId** (string, query, optional): A specific element microversion in which to evaluate the request. - **includeGeometryIds** (boolean, query, optional): If true, include the underlying geometry IDs in the feature definition. - **featureId** (array (string), query, optional): ID of a feature; repeat query param to add more than one - **noSketchGeometry** (boolean, query, optional): Whether or not to output simple sketch info without geometry ### Responses #### default - default response **BTFeatureListResponse-2457** - **btType** (string): Type of JSON object. - **defaultFeatures** (array (BTMFeature-134)): List of Onshape-defined features instantiated within the Part Studio. Array items: - **btType** (string): Type of JSON object. - **featureId** (string): Unique ID of the feature instance within this Part Studio. - **featureType** (string): The name of the feature spec that this feature instantiates. - **importMicroversion** (string): Element microversion that is being imported. - **mateConnectorFeature** (boolean) - **name** (string): User-visible name of the feature. - **namespace** (string): Indicates where the feature definition lives. Features in the FeatureScript standard library have a namespace value of `""`. Custom features identify the Feature Studio that contains the definition. - **nodeId** (string): ID for the feature node. - **parameterLibraries** (array (BTMParameter-1)) Array items: - **btType** (string): Type of JSON object. - **importMicroversion** (string): Microversion that resulted from the import. - **libraryRelationType** (string (NONE|CONTROLLED|OVERRIDE|UNKNOWN)) ("NONE"|"CONTROLLED"|"OVERRIDE"|"UNKNOWN") - **nodeId** (string): ID of the parameter's node. - **parameterId** (string): Unique ID of the parameter. - **parameterName** (string) - **valueString** (string) - **parameters** (array (BTMParameter-1)): A list of parameter values for instantiation of the feature spec. Parameters are present for all defined parameters, even if not used in a specific instantiation. Array items: - **parentSuppressed** (boolean) - **returnAfterSubfeatures** (boolean): For internal use only. Should always be `false`. - **subFeatures** (array (BTMFeature-134)): List of subfeatures belonging to the feature. Array items: - **suppressed** (boolean): If `true`, the feature is suppressed. It will skip regeneration, denoted by a line through the name in the Feature list. - **suppressionConfigured** (boolean): `true` if the suppression is configured in the Part Studio. - **suppressionState** (object) - **btType** (string) - **importMicroversion** (string): Microversion that resulted from the import. - **nodeId** (string) - **suppressionConfigured** (boolean) - **variableStudioReference** (boolean): If `true`, the feature references a Variable Studio. - **featureStates** (object): State of each feature, indicating if the feature is valid. Incorrectly defined features will still appear in the Feature list. - **features** (array (BTMFeature-134)): List of user-defined features instantiated within the Part Studio. Array items: - **imports** (array (BTMImport-136)): Internal only. Do not modify. Array items: - **btType** (string) - **importMicroversion** (string): Element microversion that is being imported. - **nodeId** (string) - **elementImport** (boolean) - **importedExternalDocumentId** (string) - **namespace** (string) - **path** (string) - **version** (string) - **isComplete** (boolean): `true` if the features represent the entire part studio or `false` for a filtered subset. - **libraryVersion** (integer (int32)): FeatureScript version used in the Part Studio. Do not modify. - **microversionSkew** (boolean): On output, `true` indicates a microversion mismatch was encountered. - **rejectMicroversionSkew** (boolean): If `true`, the call will refuse to make the addition if the current microversion for the document does not match the source microversion. If `false`, a best-effort attempt is made to re-interpret the feature addition in the context of a newer document microversion. - **rollbackIndex** (integer (int32)): Index of the rollback bar location. `-1` indicates the bar is at the end of the Feature List. - **serializationVersion** (string): Version of the structure serialization rules used to encode the output. This enables incompatibility detection during software updates. - **sourceMicroversion** (string): The document microversion from which the result was extracted. Part, face, edge, and vertex IDs are only valid for the same microversion. ### Example Usage ```bash curl -X GET "https://cad.onshape.com/api/v16/partstudios/d/{did}/{wvm}/{wvmid}/e/{eid}/features?linkDocumentId=&configuration=&rollbackBarIndex=-1&elementMicroversionId=string&includeGeometryIds=true&featureId=item1,item2&noSketchGeometry=false" ``` ``` -------------------------------- ### GET /folders/{fid}/acl Source: https://cad.onshape.com/api/openapi Returns the ACL of permission objects. Each object contains: * The type of entity * 0 (User) * 1 (Company) * 2 (Team) * 3 (Document) * 4 (Application) * The ID of the entity for the specified type. * The permissions for that entity. * OWNER (100): All permissions, including those not listed, such as permission to transfer ownership. * DELETE (90) * RESHARE (80) * WRITE (70) * READ (60) * LINK (50) * COPY (30): Can copy workspace * EXPORT (20): Can export geometry * COMMENT (10) * ANONYMOUS_ACCESS (5): Special, restricted read access ```markdown ### Parameters - **fid** (string, path, required) ### Responses #### default - default response **BTAclInfo** - **admin** (boolean) - **entries** (array (BTAclEntryInfo)) Array items: - **acceptOwnerTransfer** (boolean) - **canConnectionUserEdit** (boolean) - **companyName** (string) - **connectionId** (string) - **connectionName** (string) - **connectionUser** (boolean) - **email** (string) - **enterpriseMember** (boolean) - **entryId** (string) - **entryState** (string (DELETED|ACTIVE|INACTIVE|REQUESTED|APPROVED|REQUEST_EXPIRED|ALL|MARKED_FOR_DELETION)) ("DELETED"|"ACTIVE"|"INACTIVE"|"REQUESTED"|"APPROVED"|"REQUEST_EXPIRED"|"ALL"|"MARKED_FOR_DELETION") - **entryType** (integer (int32)) - **folderInaccessible** (boolean) - **folderName** (string) - **image** (string) - **name** (string) - **objectId** (string) - **pendingOwnerTransfer** (boolean) - **permission** (integer (int64)) - **permissionSet** (array (string)) - **proCompanySubtype** (integer (int32)) - **teamName** (string) - **href** (string (uri)): URI to fetch complete information of the resource. - **id** (string): Id of the resource. - **inheritedAcls** (array (BTInheritedAclInfo)) Array items: - **entries** (array (BTAclEntryInfo)) Array items: - **href** (string (uri)): URI to fetch complete information of the resource. - **id** (string): Id of the resource. - **name** (string): Name of the resource. - **objectId** (string) - **objectName** (string) - **objectType** (integer (int64)) - **owner** (object) - **href** (string (uri)): URI to fetch complete information of the resource. - **id** (string): Id of the resource. - **image** (string) - **isEnterpriseOwnedResource** (boolean) - **name** (string): Name of the resource. - **type** (integer (int32)) - **viewRef** (string (uri)): URI to visualize the resource in a webclient if applicable. - **public** (boolean) - **sharedWithSupport** (boolean) - **viewRef** (string (uri)): URI to visualize the resource in a webclient if applicable. - **visibility** (string) - **name** (string): Name of the resource. - **objectId** (string) - **objectType** (integer (int64)) - **owner** (object) - **public** (boolean) - **sharedWithSupport** (boolean) - **viewRef** (string (uri)): URI to visualize the resource in a webclient if applicable. - **visibility** (string) ### Example Usage ```bash curl -X GET "https://cad.onshape.com/api/v16/folders/{fid}/acl" ``` ``` -------------------------------- ### GET /documents/d/{did}/versions/{vid} Source: https://cad.onshape.com/api/openapi API endpoint for GET /documents/d/{did}/versions/{vid} ```markdown ### Parameters - **did** (string, path, required) - **vid** (string, path, required) - **parents** (boolean, query, optional) - **linkDocumentId** (string, query, optional) ### Responses #### 200 - Success! **BTVersionInfo** - **createdAt** (string (date-time)) - **creator** (object) - **href** (string (uri)): URI to fetch complete information of the resource. - **id** (string): Id of the resource. - **name** (string): Name of the resource. - **viewRef** (string (uri)): URI to visualize the resource in a webclient if applicable. - **image** (string) - **isOnshapeSupport** (boolean) - **state** (integer (int32)) - **description** (string) - **documentId** (string) - **href** (string (uri)): URI to fetch complete information of the resource. - **id** (string): Id of the resource. - **lastModifier** (object) - **metadataWorkspaceId** (string) - **microversion** (string) - **modifiedAt** (string (date-time)) - **name** (string): Name of the resource. - **overrideDate** (string (date-time)) - **parent** (string) - **purpose** (integer (int32)) - **thumbnail** (object) - **href** (string (uri)) - **id** (string) - **secondarySizes** (array (array (BTThumbnailSizeInfo))) - **sizes** (array (BTThumbnailSizeInfo)) Array items: - **href** (string (uri)) - **mediaType** (string) - **renderMode** (string) - **sheetName** (string) - **size** (string) - **uniqueId** (string) - **viewOrientation** (string) - **type** (string) - **viewRef** (string (uri)): URI to visualize the resource in a webclient if applicable. ### Example Usage ```bash curl -X GET "https://cad.onshape.com/api/v16/documents/d/{did}/versions/{vid}?parents=false&linkDocumentId=string" ``` ``` -------------------------------- ### GET /drawings/d/{did}/w/{wid}/e/{eid}/translationformats Source: https://cad.onshape.com/api/openapi See [API Guide: Translations](https://onshape-public.github.io/docs/api-adv/translation/#export-a-drawing-as-a-json) for more information. ```markdown ### Parameters - **did** (string, path, required) - **wid** (string, path, required) - **eid** (string, path, required) ### Responses #### default - default response - Array of BTModelFormatInfo ### Example Usage ```bash curl -X GET "https://cad.onshape.com/api/v16/drawings/d/{did}/w/{wid}/e/{eid}/translationformats" ``` ```